KDE 4.9 PyKDE API Reference

- KDE's Python API

# KPixmapCache Class Reference

`from PyKDE4.kdeui import *`

Subclasses: KIconCache

## Detailed Description

General-purpose pixmap cache for KDE.

The pixmap cache can be used to store pixmaps which can later be loaded from the cache very quickly.

Its most common use is storing SVG images which might be expensive to render every time they are used. With the cache you can render each SVG only once and later use the stored version unless the SVG file or requested pixmap size changes.

KPixmapCache's API is similar to that of the QPixmapCache so if you're already using the latter then all you need to do is creating a KPixmapCache object (unlike QPixmapCache, KPixmapCache doesn't have many static methods) and calling insert() and find() method on that object:

      // Create KPixmapCache object
      KPixmapCache* cache = new KPixmapCache("myapp-pixmaps");
      // Load a pixmap
      QPixmap pix;
      if (!cache->find("pixmap-1", pix)) {
          // Pixmap isn't in the cache, create it and insert to cache
          pix = createPixmapFromData();
          cache->insert("pixmap-1", pix);
      }
      // Use pix

The above example illustrates that you can also cache pixmaps created from some data. In case such data is updated, you might need to discard cache contents using discard() method:

     // Discard the cache if it's too old
     if (cache->timestamp() < mydataTimestamp()) {
         cache->discard();
     }
     // Now the cache contains up-to-date data

As demonstrated, you can use cache's timestamp() method to see when the cache was created. If necessary, you can also change the timestamp using setTimestamp() method.

Deprecated:
  KPixmapCache is susceptible to various non-trivial locking bugs and inefficiencies, and is supported for backward compatibility only (since it exposes a QDataStream API for subclasses). Users should port to KImageCache for a very close work-alike, or KSharedDataCache if they need more control.

See also:
  KImageCache, KSharedDataCache

Author:
  Rivo Laks

## Enumerations

RemoveStrategy | { RemoveOldest, RemoveSeldomUsed, RemoveLeastRecentlyUsed }

## Methods

| __init__ (self, KPixmapCache other)
| __init__ (self, QString name)
int | cacheLimit (self)
| discard (self)
| ensureInited (self)
bool | find (self, QString key, QPixmap pix)
| insert (self, QString key, QPixmap pix)
bool | isEnabled (self)
bool | isValid (self)
bool | loadCustomData (self, QDataStream stream)
bool | loadCustomIndexHeader (self, QDataStream stream)
QPixmap | loadFromFile (self, QString filename)
QPixmap | loadFromSvg (self, QString filename, QSize size=QSize())
bool | recreateCacheFiles (self)
| removeEntries (self, int newsize=0)
KPixmapCache.RemoveStrategy | removeEntryStrategy (self)
| setCacheLimit (self, int kbytes)
| setRemoveEntryStrategy (self, KPixmapCache.RemoveStrategy strategy)
| setTimestamp (self, long time)
| setUseQPixmapCache (self, bool use)
| setValid (self, bool valid)
int | size (self)
long | timestamp (self)
bool | useQPixmapCache (self)
bool | writeCustomData (self, QDataStream stream)
| writeCustomIndexHeader (self, QDataStream stream)

## Static Methods

| deleteCache (QString name)

## Method Documentation

__init__ | ( | self, |
|  | KPixmapCache | other
| ) |  |  |

__init__ | ( | self, |
|  | QString | name
| ) |  |  |

Constucts the pixmap cache object.

Parameters:

  | name | unique name of the cache

int cacheLimit | ( |  | self ) |

Returns:
  maximum size of the cache (in kilobytes). Default setting is 3 megabytes (1 megabyte = 2^20 bytes).

discard | ( |  | self ) |

Deletes all entries and reinitializes this cache.

NOTE: If useQPixmapCache is set to true then that cache must also be cleared. There is only one QPixmapCache for the entire process however so other KPixmapCaches and other QPixmapCache users may also be affected, leading to a temporary slowdown until the QPixmapCache is repopulated.

ensureInited | ( |  | self ) |

Makes sure that the cache is initialized correctly, including the loading of the cache index and data, and any shared memory attachments (for systems where that is enabled).

Note:
  Although this method is protected you should not use it from any subclasses.

Internal:

bool find | ( | self, |
|  | QString | key,
|  | QPixmap | pix
| ) |  |  |

Tries to load pixmap with the specified key from cache. If the pixmap is found it is stored in pix, otherwise pix is unchanged.

Returns:
  true when pixmap was found and loaded from cache, false otherwise

insert | ( | self, |
|  | QString | key,
|  | QPixmap | pix
| ) |  |  |

Inserts the pixmap pix into the cache, associated with the key key.

Any existing pixmaps associated with key are overwritten.

bool isEnabled | ( |  | self ) |

Cache will be disabled when e.g. its data file cannot be created or read.

Returns:
  true when the cache is enabled.

bool isValid | ( |  | self ) |

Returns:
  true when the cache is ready to be used. Not being valid usually means that some additional initialization has to be done before the cache can be used.

bool loadCustomData | ( | self, |
|  | QDataStream | stream
| ) |  |  |

Can be used by subclasses to load custom data from the stream. This function will be called by KPixmapCache immediately following the image data for a single image being read from stream. (This function is called once for every single image).

See also:
  writeCustomData

See also:
  loadCustomIndexHeader

Parameters:

  | stream | the QDataStream to read data from

Returns:
  true if custom data was successfully loaded, false otherwise. If false is returned then the cached item is assumed to be invalid and will not be available to find() or contains().

bool loadCustomIndexHeader | ( | self, |
|  | QDataStream | stream
| ) |  |  |

Can be used by subclasses to load custom data from cache's header. This function will be called by KPixmapCache immediately after the index header has been written out. (This function is called one time only for the entire cache).

See also:
  loadCustomData

See also:
  writeCustomIndexHeader

Parameters:

  | stream | the QDataStream to read data from

Returns:
  true if custom index header data was successfully read, false otherwise. If false is returned then the cache is assumed to be invalid and further processing does not occur.

QPixmap loadFromFile | ( | self, |
|  | QString | filename
| ) |  |  |

Loads a pixmap from given file, using the cache. If the file does not exist on disk, an empty pixmap is returned, even if that file had previously been cached. In addition, if the file's modified-time is more recent than cache's timestamp(), the entire cache is discarded (to be regenerated). This behavior may change in a future KDE Platform release. If the cached data is current the pixmap is returned directly from the cache without any file loading.

Note:
  The mapping between filename and the actual key used internally is implementation-dependent and can change without warning. Use insert() manually if you need control of the key, otherwise consistently use this function.

Parameters:

  | filename | The name of the pixmap to load, cache, and return.

Returns:
  The given pixmap, or an empty pixmap if the file was invalid or did not exist.

QPixmap loadFromSvg | ( | self, |
|  | QString | filename,
|  | QSize | size=QSize()
| ) |  |  |

Same as loadFromFile(), but using an SVG file instead. You may optionally pass in a size to control the size of the output pixmap.

Note:
  The returned pixmap is only cached for identical filenames and sizes. If you change the size in between calls to this function then the pixmap will have to be regenerated again.

Parameters:

  | filename | The filename of the SVG file to load.
  | size | size of the pixmap where the SVG is render to. If not given then the SVG file's default size is used.

Returns:
  an empty pixmap if the file does not exist or was invalid, otherwise a pixmap of the desired size.

bool recreateCacheFiles | ( |  | self ) |

This function causes the cache files to be recreate by invalidating the cache. Any shared memory mappings (if enabled) are dropped temporarily as well.

Note:
  The recreated cache will be initially empty, but with the same size limits and entry removal strategy (see removeEntryStrategy()).

If you use this in a subclass be prepared to handle writeCustomData() and writeCustomIndexHeader().

Returns:
  true if the cache was successfully recreated.

removeEntries | ( | self, |
|  | int | newsize=0
| ) |  |  |

Removes some of the entries in the cache according to current removeEntryStrategy().

Parameters:

  | newsize | wanted size of the cache, in bytes. If 0 is given then current cacheLimit() is used.

Warning:
  This currently works by copying some entries to a new cache and then replacing the old cache with the new one. Thus it might be slow and will temporarily use extra disk space.

KPixmapCache.RemoveStrategy removeEntryStrategy | ( |  | self ) |

Returns:
  current entry removal strategy. Default is RemoveLeastRecentlyUsed.

setCacheLimit | ( | self, |
|  | int | kbytes
| ) |  |  |

Sets the maximum size of the cache (in kilobytes). If cache gets bigger than the limit then some entries are removed (according to removeEntryStrategy()).

Setting the cache limit to 0 disables caching (as all entries will get immediately removed).

Note that the cleanup might not be done immediately, so the cache might temporarily (for a few seconds) grow bigger than the limit.

setRemoveEntryStrategy | ( | self, |
|  | KPixmapCache.RemoveStrategy | strategy
| ) |  |  |

Sets the removeEntryStrategy used when removing entries.

setTimestamp | ( | self, |
|  | long | time
| ) |  |  |

Sets the timestamp of app-specific cache. It's saved in the cache file and can later be retrieved using the timestamp() method. By default the timestamp is set to the cache creation time.

setUseQPixmapCache | ( | self, |
|  | bool | use
| ) |  |  |

Sets whether QPixmapCache (memory caching) should be used in addition to disk cache. QPixmapCache is used by default.

Note:
  On most systems KPixmapCache can use shared-memory to share cached pixmaps with other applications attached to the same shared pixmap, which means additional memory caching is unnecessary and actually wasteful of memory.

Warning:
  QPixmapCache is shared among the entire process and therefore can cause strange interactions with other instances of KPixmapCache. This may be fixed in the future and should be not relied upon.

setValid | ( | self, |
|  | bool | valid
| ) |  |  |

Sets whether this cache is valid or not. (The cache must be enabled in addition for isValid() to return true.

See also:
  isEnabled(),
  See also:
    setEnabled()).

  Most cache functions do not work if the cache is not valid. KPixmapCache assumes the cache is valid as long as its cache files were able to be created (see recreateCacheFiles()) even if the cache is not enabled.

  Can be used by subclasses to indicate that cache needs some additional initialization before it can be used (note that KPixmapCache will not handle actually performing this extra initialization).

int size | ( |  | self ) |

Returns:
  approximate size of the cache, in kilobytes (1 kilobyte == 1024 bytes)

long timestamp | ( |  | self ) |

Note:
  KPixmapCache does not ever change the timestamp, so the application must set the timestamp if it to be used.

Returns:
  Timestamp of the cache, set using the setTimestamp() method.

bool useQPixmapCache | ( |  | self ) |

Whether QPixmapCache should be used to cache pixmaps in memory in addition to caching them on the disk.

NOTE: The design of QPixmapCache means that the entries stored in the cache are shared throughout the entire process, and not just in this particular KPixmapCache. KPixmapCache makes an effort to ensure that entries from other KPixmapCaches do not inadvertently spill over into this one, but is not entirely successful (see discard())

bool writeCustomData | ( | self, |
|  | QDataStream | stream
| ) |  |  |

Can be used by subclasses to write custom data into the stream. This function will be called by KPixmapCache immediately after the image data for a single image has been written to stream. (This function is called once for every single image).

See also:
  loadCustomData

See also:
  writeCustomIndexHeader

Parameters:

  | stream | the QDataStream to write data to

writeCustomIndexHeader | ( | self, |
|  | QDataStream | stream
| ) |  |  |

Can be used by subclasses to write custom data into cache's header. This function will be called by KPixmapCache immediately following the index header has being loaded. (This function is called one time only for the entire cache).

See also:
  writeCustomData

See also:
  loadCustomIndexHeader

Parameters:

  | stream | the QDataStream to write data to

## Static Method Documentation

deleteCache | ( | QString | name
| ) |  |  |

Deletes a pixmap cache.

Parameters:

  | name | unique name of the cache to be deleted

## Enumeration Documentation

RemoveStrategy

Describes which entries will be removed first during cache cleanup.

See also:
  removeEntryStrategy(),
  See also:
    setRemoveEntryStrategy()
  Enumerator:

    RemoveOldest |
    RemoveSeldomUsed |
    RemoveLeastRecentlyUsed |